#include<iostream>
using namespace std;
const int N=1000001;
int l[N],r[N],a[N];
int m,ans=1;
//用l数组存左孩子 r数组存右孩子 a为权值 m为总结点数 ans为结果 
bool f;
//用f标记结构是否对称 
int dfs(int x,int y,int s)
//这是个找对称二叉树的函数 s代表节点数 x,y为正在访问的节点标号 
{
    if(x==-1&&y==-1) return 0;//判断是否有节点 
    if(x==-1||y==-1&&x!=y)
    {
        f=1;
        return 0;
    } 
    //判断结构是否对称 
    if(a[x]!=a[y])
    {
        f=1;
        return 0;
    }
    //判断权值是否对称 ，并标记 
    return dfs(l[x],r[y],2)+dfs(r[x],l[y],2)+s;
    //继续往下以对称的形式递归：返回值为下面的节点数加上上面的节点数 
}

int main(){
    cin>>m;//输入节点数 
    for(int i=1;i<=m;i++) cin>>a[i];//输入权值 
    for(int i=1;i<=m;i++)
    {
        cin>>l[i];
        cin>>r[i];
    }//输入左孩子和右孩子标号 
    for(int i=1;i<=m;i++) 
    {
        int s=dfs(l[i],r[i],3);
        //注意：这里因为是直接从访问的节点的左孩子和右孩子开始访问所以初始节点为三个 
        if(s>ans&&f==0) ans=s;
        f=0;
        //然后就是判断大小和擦除标记 
    }
    cout<<ans;//最后再来个输出，就完事啦 
    return 0;
}